#include <stdio.h>
#include "data.h"

/* The RX simulator knows about these */
#define TPU1_TCNT (*(unsigned short *)0x00088126)
#define TPU2_TCNT (*(unsigned short *)0x00088136)

static inline long long
get_clocks ()
{
  unsigned short ch, cl, ch2;
  unsigned int clocks;
  do {
    ch = TPU1_TCNT;
    cl = TPU2_TCNT;
    ch2 = TPU1_TCNT;
  } while (ch != ch2);

  clocks = ((unsigned int)ch << 16) | (unsigned int)cl;
  return clocks;
}

main()
{
  long long full_clocks, half_clocks, clocks;

  TPU1_TCNT = 0;
  data_result = mac (data_a, data_b, data_length/2);
  half_clocks = get_clocks ();

  TPU1_TCNT = 0;
  data_result = mac (data_a, data_b, data_length);
  full_clocks = get_clocks ();

  clocks = (full_clocks - half_clocks) * 2;
  printf("%d clocks (%.1f per datum)\n", (int)clocks, (double)clocks / (data_length-data_length/2));
  printf("%lld result\n", data_result);

  return 0;
}
